/* -------------------------------------------------------------------------------------------------------------------------
* Project           :C-to-FPGA Solution for Acclerating Tomographic Reconstruction
* File Name         :uwer_SystemMatrix.c (from project UW Emission Reconstruction) 
*                    Copyright (c) 2004 University of Washington - Imaging Research Laboratory. All rights reserved.
* Version           :1.0 (V1)
* (V1)Author        :Adam Alessio
* (V1)Created       :Wed, Jan 14 2004
* References        :
* Description       :
*
******This file may not be distributed or modified without this header*****
*-------------------------------------------------------------------------------------------------------------------------*/


#ifndef UWER_SYSTEMMATRIX_H
#define UWER_SYSTEMMATRIX_H

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

//#include <Carbon/Carbon.h>
#include "structs.h"

void generate_system_matrix_PSF21(struct sino_info *sinoInfo,
			    struct recon_image_info *imageInfo,
				  struct system_matrix_info *systemInfo,struct exec_parameters *params);

void generate_system_matrix(struct sino_info *sinoInfo,
		     struct recon_image_info *imageInfo,
			    struct system_matrix_info *systemInfo,struct exec_parameters *params);


void system_matrix_j_PSF21(int im_row, int im_col,int subset,
		     struct sino_info *sinoInfo,
		     struct recon_image_info *imageInfo,
		     struct system_matrix_info *sysMat,int plane);

void system_matrix_j(int im_row, int im_col, int im_subset,
		     struct sino_info *sinoInfo,
		     struct recon_image_info *imageInfo,
		     struct system_matrix_info *systemInfo);

     
void get_one_p_column_for_j(int im_row, int im_col,
			     double xPixelSize,double yPixelSize,double tfov,
			     struct sino_info *sinoInfo,
			    struct recon_image_info *imageInfo,
			    double ***pix_prof,
			    struct p_column_dbl *one_p_column);

void find_pixel_contributions(struct sino_info *sinoInfo,struct recon_image_info *imageInfo, double ***pixelCont);

double proj_shape_rect(double t, double projWidth);
double proj_shape_triangle(double t, double projWidth);

#endif
