/* -------------------------------------------------------------------------------------------------------------------------
* Project           :C-to-FPGA Solution for Acclerating Tomographic Reconstruction
* File Name         :uwer_fbp.h (from project UW Emission Reconstruction) 
*                    Copyright (c) 2004 University of Washington - Imaging Research Laboratory. All rights reserved.
* Version           :1.0 (V1)
* (V1)Author        :Adam Alessio ( * Modified from code written by Charles Bouman and Ken Sauer.)
* (V1)Created       :Wed, Jan 14 2004
* References        :
* Description       :Header info for uwer_fbp.c
*
******This file may not be distributed or modified without this header*****
*-------------------------------------------------------------------------------------------------------------------------*/


#ifndef UWER_FBP_H
#define UWER_FBP_H

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#include "structs.h"
#include "allocate.h"
#include "fft.h"

void fbp_recon(struct sino_info *sinoInfo,
		  struct recon_image_info *imageInfo,
	       struct exec_parameters *params);


void filter_sino(float **sinogramData,struct sino_info *sino,struct fbp_filter* filter);

void GHamming_Filter(int n,struct sino_info *sino,struct fbp_filter* filter);
void Ramp_Filter(int n,struct sino_info *sino,struct fbp_filter* filter);
void conv(double *out, double *in1, int len1, double *in2, int len2);
void normalize_filter_to_sum1(double *filt, int len);
double hrl(int m, struct sino_info *sino);
double dhrl(double m, struct sino_info *sino);
void backproject(float **image,float **sinogramData,struct sino_info *sino,struct recon_image_info *geom);
double interpolate(double findex, float **Y, int angle_index);
void mean_value_correct(float **image, double pmass, struct recon_image_info *geom);
double calc_pmass(float **sinogramData, struct sino_info *sino, struct recon_image_info *imageInfo);
double min(float **img,int N, int M);
double max(float **img,int N, int M);
void cut_freq(double *filter,double del,int n);
double snc(double n);


#endif
